# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

    OpenAPI spec version: v2
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class BillingPlanResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, billing_plan=None, successor_plans=None):
        """
        BillingPlanResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'billing_plan': 'BillingPlan',
            'successor_plans': 'list[BillingPlan]'
        }

        self.attribute_map = {
            'billing_plan': 'billingPlan',
            'successor_plans': 'successorPlans'
        }

        self._billing_plan = billing_plan
        self._successor_plans = successor_plans

    @property
    def billing_plan(self):
        """
        Gets the billing_plan of this BillingPlanResponse.

        :return: The billing_plan of this BillingPlanResponse.
        :rtype: BillingPlan
        """
        return self._billing_plan

    @billing_plan.setter
    def billing_plan(self, billing_plan):
        """
        Sets the billing_plan of this BillingPlanResponse.

        :param billing_plan: The billing_plan of this BillingPlanResponse.
        :type: BillingPlan
        """

        self._billing_plan = billing_plan

    @property
    def successor_plans(self):
        """
        Gets the successor_plans of this BillingPlanResponse.
        

        :return: The successor_plans of this BillingPlanResponse.
        :rtype: list[BillingPlan]
        """
        return self._successor_plans

    @successor_plans.setter
    def successor_plans(self, successor_plans):
        """
        Sets the successor_plans of this BillingPlanResponse.
        

        :param successor_plans: The successor_plans of this BillingPlanResponse.
        :type: list[BillingPlan]
        """

        self._successor_plans = successor_plans

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
