# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

    OpenAPI spec version: v2
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class BulkEnvelopeStatus(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, batch_id=None, batch_size=None, bulk_envelopes=None, bulk_envelopes_batch_uri=None, end_position=None, failed=None, next_uri=None, previous_uri=None, queued=None, result_set_size=None, sent=None, start_position=None, submitted_date=None, total_set_size=None):
        """
        BulkEnvelopeStatus - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'batch_id': 'str',
            'batch_size': 'str',
            'bulk_envelopes': 'list[BulkEnvelope]',
            'bulk_envelopes_batch_uri': 'str',
            'end_position': 'str',
            'failed': 'str',
            'next_uri': 'str',
            'previous_uri': 'str',
            'queued': 'str',
            'result_set_size': 'str',
            'sent': 'str',
            'start_position': 'str',
            'submitted_date': 'str',
            'total_set_size': 'str'
        }

        self.attribute_map = {
            'batch_id': 'batchId',
            'batch_size': 'batchSize',
            'bulk_envelopes': 'bulkEnvelopes',
            'bulk_envelopes_batch_uri': 'bulkEnvelopesBatchUri',
            'end_position': 'endPosition',
            'failed': 'failed',
            'next_uri': 'nextUri',
            'previous_uri': 'previousUri',
            'queued': 'queued',
            'result_set_size': 'resultSetSize',
            'sent': 'sent',
            'start_position': 'startPosition',
            'submitted_date': 'submittedDate',
            'total_set_size': 'totalSetSize'
        }

        self._batch_id = batch_id
        self._batch_size = batch_size
        self._bulk_envelopes = bulk_envelopes
        self._bulk_envelopes_batch_uri = bulk_envelopes_batch_uri
        self._end_position = end_position
        self._failed = failed
        self._next_uri = next_uri
        self._previous_uri = previous_uri
        self._queued = queued
        self._result_set_size = result_set_size
        self._sent = sent
        self._start_position = start_position
        self._submitted_date = submitted_date
        self._total_set_size = total_set_size

    @property
    def batch_id(self):
        """
        Gets the batch_id of this BulkEnvelopeStatus.
        Specifies an identifier which can be used to retrieve a more detailed status of individual bulk recipient batches.

        :return: The batch_id of this BulkEnvelopeStatus.
        :rtype: str
        """
        return self._batch_id

    @batch_id.setter
    def batch_id(self, batch_id):
        """
        Sets the batch_id of this BulkEnvelopeStatus.
        Specifies an identifier which can be used to retrieve a more detailed status of individual bulk recipient batches.

        :param batch_id: The batch_id of this BulkEnvelopeStatus.
        :type: str
        """

        self._batch_id = batch_id

    @property
    def batch_size(self):
        """
        Gets the batch_size of this BulkEnvelopeStatus.
        The number of items returned in this response.

        :return: The batch_size of this BulkEnvelopeStatus.
        :rtype: str
        """
        return self._batch_size

    @batch_size.setter
    def batch_size(self, batch_size):
        """
        Sets the batch_size of this BulkEnvelopeStatus.
        The number of items returned in this response.

        :param batch_size: The batch_size of this BulkEnvelopeStatus.
        :type: str
        """

        self._batch_size = batch_size

    @property
    def bulk_envelopes(self):
        """
        Gets the bulk_envelopes of this BulkEnvelopeStatus.
        Reserved: TBD

        :return: The bulk_envelopes of this BulkEnvelopeStatus.
        :rtype: list[BulkEnvelope]
        """
        return self._bulk_envelopes

    @bulk_envelopes.setter
    def bulk_envelopes(self, bulk_envelopes):
        """
        Sets the bulk_envelopes of this BulkEnvelopeStatus.
        Reserved: TBD

        :param bulk_envelopes: The bulk_envelopes of this BulkEnvelopeStatus.
        :type: list[BulkEnvelope]
        """

        self._bulk_envelopes = bulk_envelopes

    @property
    def bulk_envelopes_batch_uri(self):
        """
        Gets the bulk_envelopes_batch_uri of this BulkEnvelopeStatus.
        Reserved: TBD

        :return: The bulk_envelopes_batch_uri of this BulkEnvelopeStatus.
        :rtype: str
        """
        return self._bulk_envelopes_batch_uri

    @bulk_envelopes_batch_uri.setter
    def bulk_envelopes_batch_uri(self, bulk_envelopes_batch_uri):
        """
        Sets the bulk_envelopes_batch_uri of this BulkEnvelopeStatus.
        Reserved: TBD

        :param bulk_envelopes_batch_uri: The bulk_envelopes_batch_uri of this BulkEnvelopeStatus.
        :type: str
        """

        self._bulk_envelopes_batch_uri = bulk_envelopes_batch_uri

    @property
    def end_position(self):
        """
        Gets the end_position of this BulkEnvelopeStatus.
        The last position in the result set. 

        :return: The end_position of this BulkEnvelopeStatus.
        :rtype: str
        """
        return self._end_position

    @end_position.setter
    def end_position(self, end_position):
        """
        Sets the end_position of this BulkEnvelopeStatus.
        The last position in the result set. 

        :param end_position: The end_position of this BulkEnvelopeStatus.
        :type: str
        """

        self._end_position = end_position

    @property
    def failed(self):
        """
        Gets the failed of this BulkEnvelopeStatus.
        The number of entries with a status of failed. 

        :return: The failed of this BulkEnvelopeStatus.
        :rtype: str
        """
        return self._failed

    @failed.setter
    def failed(self, failed):
        """
        Sets the failed of this BulkEnvelopeStatus.
        The number of entries with a status of failed. 

        :param failed: The failed of this BulkEnvelopeStatus.
        :type: str
        """

        self._failed = failed

    @property
    def next_uri(self):
        """
        Gets the next_uri of this BulkEnvelopeStatus.
        The URI to the next chunk of records based on the search request. If the endPosition is the entire results of the search, this is null. 

        :return: The next_uri of this BulkEnvelopeStatus.
        :rtype: str
        """
        return self._next_uri

    @next_uri.setter
    def next_uri(self, next_uri):
        """
        Sets the next_uri of this BulkEnvelopeStatus.
        The URI to the next chunk of records based on the search request. If the endPosition is the entire results of the search, this is null. 

        :param next_uri: The next_uri of this BulkEnvelopeStatus.
        :type: str
        """

        self._next_uri = next_uri

    @property
    def previous_uri(self):
        """
        Gets the previous_uri of this BulkEnvelopeStatus.
        The postal code for the billing address.

        :return: The previous_uri of this BulkEnvelopeStatus.
        :rtype: str
        """
        return self._previous_uri

    @previous_uri.setter
    def previous_uri(self, previous_uri):
        """
        Sets the previous_uri of this BulkEnvelopeStatus.
        The postal code for the billing address.

        :param previous_uri: The previous_uri of this BulkEnvelopeStatus.
        :type: str
        """

        self._previous_uri = previous_uri

    @property
    def queued(self):
        """
        Gets the queued of this BulkEnvelopeStatus.
        The number of entries with a status of queued. 

        :return: The queued of this BulkEnvelopeStatus.
        :rtype: str
        """
        return self._queued

    @queued.setter
    def queued(self, queued):
        """
        Sets the queued of this BulkEnvelopeStatus.
        The number of entries with a status of queued. 

        :param queued: The queued of this BulkEnvelopeStatus.
        :type: str
        """

        self._queued = queued

    @property
    def result_set_size(self):
        """
        Gets the result_set_size of this BulkEnvelopeStatus.
        The number of results returned in this response. 

        :return: The result_set_size of this BulkEnvelopeStatus.
        :rtype: str
        """
        return self._result_set_size

    @result_set_size.setter
    def result_set_size(self, result_set_size):
        """
        Sets the result_set_size of this BulkEnvelopeStatus.
        The number of results returned in this response. 

        :param result_set_size: The result_set_size of this BulkEnvelopeStatus.
        :type: str
        """

        self._result_set_size = result_set_size

    @property
    def sent(self):
        """
        Gets the sent of this BulkEnvelopeStatus.
        The number of entries with a status of sent.

        :return: The sent of this BulkEnvelopeStatus.
        :rtype: str
        """
        return self._sent

    @sent.setter
    def sent(self, sent):
        """
        Sets the sent of this BulkEnvelopeStatus.
        The number of entries with a status of sent.

        :param sent: The sent of this BulkEnvelopeStatus.
        :type: str
        """

        self._sent = sent

    @property
    def start_position(self):
        """
        Gets the start_position of this BulkEnvelopeStatus.
        Starting position of the current result set.

        :return: The start_position of this BulkEnvelopeStatus.
        :rtype: str
        """
        return self._start_position

    @start_position.setter
    def start_position(self, start_position):
        """
        Sets the start_position of this BulkEnvelopeStatus.
        Starting position of the current result set.

        :param start_position: The start_position of this BulkEnvelopeStatus.
        :type: str
        """

        self._start_position = start_position

    @property
    def submitted_date(self):
        """
        Gets the submitted_date of this BulkEnvelopeStatus.
        

        :return: The submitted_date of this BulkEnvelopeStatus.
        :rtype: str
        """
        return self._submitted_date

    @submitted_date.setter
    def submitted_date(self, submitted_date):
        """
        Sets the submitted_date of this BulkEnvelopeStatus.
        

        :param submitted_date: The submitted_date of this BulkEnvelopeStatus.
        :type: str
        """

        self._submitted_date = submitted_date

    @property
    def total_set_size(self):
        """
        Gets the total_set_size of this BulkEnvelopeStatus.
        The total number of items available in the result set. This will always be greater than or equal to the value of the property returning the results in the in the response.

        :return: The total_set_size of this BulkEnvelopeStatus.
        :rtype: str
        """
        return self._total_set_size

    @total_set_size.setter
    def total_set_size(self, total_set_size):
        """
        Sets the total_set_size of this BulkEnvelopeStatus.
        The total number of items available in the result set. This will always be greater than or equal to the value of the property returning the results in the in the response.

        :param total_set_size: The total_set_size of this BulkEnvelopeStatus.
        :type: str
        """

        self._total_set_size = total_set_size

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
