# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

    OpenAPI spec version: v2
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class NewAccountSummary(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, account_id=None, account_id_guid=None, account_name=None, api_password=None, base_url=None, billing_plan_preview=None, user_id=None):
        """
        NewAccountSummary - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'account_id': 'str',
            'account_id_guid': 'str',
            'account_name': 'str',
            'api_password': 'str',
            'base_url': 'str',
            'billing_plan_preview': 'BillingPlanPreview',
            'user_id': 'str'
        }

        self.attribute_map = {
            'account_id': 'accountId',
            'account_id_guid': 'accountIdGuid',
            'account_name': 'accountName',
            'api_password': 'apiPassword',
            'base_url': 'baseUrl',
            'billing_plan_preview': 'billingPlanPreview',
            'user_id': 'userId'
        }

        self._account_id = account_id
        self._account_id_guid = account_id_guid
        self._account_name = account_name
        self._api_password = api_password
        self._base_url = base_url
        self._billing_plan_preview = billing_plan_preview
        self._user_id = user_id

    @property
    def account_id(self):
        """
        Gets the account_id of this NewAccountSummary.
        The account ID associated with the envelope.

        :return: The account_id of this NewAccountSummary.
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """
        Sets the account_id of this NewAccountSummary.
        The account ID associated with the envelope.

        :param account_id: The account_id of this NewAccountSummary.
        :type: str
        """

        self._account_id = account_id

    @property
    def account_id_guid(self):
        """
        Gets the account_id_guid of this NewAccountSummary.
        The GUID associated with the account ID.

        :return: The account_id_guid of this NewAccountSummary.
        :rtype: str
        """
        return self._account_id_guid

    @account_id_guid.setter
    def account_id_guid(self, account_id_guid):
        """
        Sets the account_id_guid of this NewAccountSummary.
        The GUID associated with the account ID.

        :param account_id_guid: The account_id_guid of this NewAccountSummary.
        :type: str
        """

        self._account_id_guid = account_id_guid

    @property
    def account_name(self):
        """
        Gets the account_name of this NewAccountSummary.
        The account name for the new account.

        :return: The account_name of this NewAccountSummary.
        :rtype: str
        """
        return self._account_name

    @account_name.setter
    def account_name(self, account_name):
        """
        Sets the account_name of this NewAccountSummary.
        The account name for the new account.

        :param account_name: The account_name of this NewAccountSummary.
        :type: str
        """

        self._account_name = account_name

    @property
    def api_password(self):
        """
        Gets the api_password of this NewAccountSummary.
        Contains a token that can be used for authentication in API calls instead of using the user name and password.

        :return: The api_password of this NewAccountSummary.
        :rtype: str
        """
        return self._api_password

    @api_password.setter
    def api_password(self, api_password):
        """
        Sets the api_password of this NewAccountSummary.
        Contains a token that can be used for authentication in API calls instead of using the user name and password.

        :param api_password: The api_password of this NewAccountSummary.
        :type: str
        """

        self._api_password = api_password

    @property
    def base_url(self):
        """
        Gets the base_url of this NewAccountSummary.
        The URL that should be used for successive calls to this account. It includes the protocal (https), the DocuSign server where the account is located, and the account number. Use this Url to make API calls against this account. Many of the API calls provide Uri's that are relative to this baseUrl.

        :return: The base_url of this NewAccountSummary.
        :rtype: str
        """
        return self._base_url

    @base_url.setter
    def base_url(self, base_url):
        """
        Sets the base_url of this NewAccountSummary.
        The URL that should be used for successive calls to this account. It includes the protocal (https), the DocuSign server where the account is located, and the account number. Use this Url to make API calls against this account. Many of the API calls provide Uri's that are relative to this baseUrl.

        :param base_url: The base_url of this NewAccountSummary.
        :type: str
        """

        self._base_url = base_url

    @property
    def billing_plan_preview(self):
        """
        Gets the billing_plan_preview of this NewAccountSummary.

        :return: The billing_plan_preview of this NewAccountSummary.
        :rtype: BillingPlanPreview
        """
        return self._billing_plan_preview

    @billing_plan_preview.setter
    def billing_plan_preview(self, billing_plan_preview):
        """
        Sets the billing_plan_preview of this NewAccountSummary.

        :param billing_plan_preview: The billing_plan_preview of this NewAccountSummary.
        :type: BillingPlanPreview
        """

        self._billing_plan_preview = billing_plan_preview

    @property
    def user_id(self):
        """
        Gets the user_id of this NewAccountSummary.
        Specifies the user ID of the new user.

        :return: The user_id of this NewAccountSummary.
        :rtype: str
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """
        Sets the user_id of this NewAccountSummary.
        Specifies the user ID of the new user.

        :param user_id: The user_id of this NewAccountSummary.
        :type: str
        """

        self._user_id = user_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
