# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

    OpenAPI spec version: v2
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class NewUser(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, api_password=None, created_date_time=None, email=None, error_details=None, permission_profile_id=None, permission_profile_name=None, uri=None, user_id=None, user_name=None, user_status=None):
        """
        NewUser - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'api_password': 'str',
            'created_date_time': 'str',
            'email': 'str',
            'error_details': 'ErrorDetails',
            'permission_profile_id': 'str',
            'permission_profile_name': 'str',
            'uri': 'str',
            'user_id': 'str',
            'user_name': 'str',
            'user_status': 'str'
        }

        self.attribute_map = {
            'api_password': 'apiPassword',
            'created_date_time': 'createdDateTime',
            'email': 'email',
            'error_details': 'errorDetails',
            'permission_profile_id': 'permissionProfileId',
            'permission_profile_name': 'permissionProfileName',
            'uri': 'uri',
            'user_id': 'userId',
            'user_name': 'userName',
            'user_status': 'userStatus'
        }

        self._api_password = api_password
        self._created_date_time = created_date_time
        self._email = email
        self._error_details = error_details
        self._permission_profile_id = permission_profile_id
        self._permission_profile_name = permission_profile_name
        self._uri = uri
        self._user_id = user_id
        self._user_name = user_name
        self._user_status = user_status

    @property
    def api_password(self):
        """
        Gets the api_password of this NewUser.
        Contains a token that can be used for authentication in API calls instead of using the user name and password.

        :return: The api_password of this NewUser.
        :rtype: str
        """
        return self._api_password

    @api_password.setter
    def api_password(self, api_password):
        """
        Sets the api_password of this NewUser.
        Contains a token that can be used for authentication in API calls instead of using the user name and password.

        :param api_password: The api_password of this NewUser.
        :type: str
        """

        self._api_password = api_password

    @property
    def created_date_time(self):
        """
        Gets the created_date_time of this NewUser.
        Indicates the date and time the item was created.

        :return: The created_date_time of this NewUser.
        :rtype: str
        """
        return self._created_date_time

    @created_date_time.setter
    def created_date_time(self, created_date_time):
        """
        Sets the created_date_time of this NewUser.
        Indicates the date and time the item was created.

        :param created_date_time: The created_date_time of this NewUser.
        :type: str
        """

        self._created_date_time = created_date_time

    @property
    def email(self):
        """
        Gets the email of this NewUser.
        

        :return: The email of this NewUser.
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """
        Sets the email of this NewUser.
        

        :param email: The email of this NewUser.
        :type: str
        """

        self._email = email

    @property
    def error_details(self):
        """
        Gets the error_details of this NewUser.

        :return: The error_details of this NewUser.
        :rtype: ErrorDetails
        """
        return self._error_details

    @error_details.setter
    def error_details(self, error_details):
        """
        Sets the error_details of this NewUser.

        :param error_details: The error_details of this NewUser.
        :type: ErrorDetails
        """

        self._error_details = error_details

    @property
    def permission_profile_id(self):
        """
        Gets the permission_profile_id of this NewUser.
        

        :return: The permission_profile_id of this NewUser.
        :rtype: str
        """
        return self._permission_profile_id

    @permission_profile_id.setter
    def permission_profile_id(self, permission_profile_id):
        """
        Sets the permission_profile_id of this NewUser.
        

        :param permission_profile_id: The permission_profile_id of this NewUser.
        :type: str
        """

        self._permission_profile_id = permission_profile_id

    @property
    def permission_profile_name(self):
        """
        Gets the permission_profile_name of this NewUser.
        

        :return: The permission_profile_name of this NewUser.
        :rtype: str
        """
        return self._permission_profile_name

    @permission_profile_name.setter
    def permission_profile_name(self, permission_profile_name):
        """
        Sets the permission_profile_name of this NewUser.
        

        :param permission_profile_name: The permission_profile_name of this NewUser.
        :type: str
        """

        self._permission_profile_name = permission_profile_name

    @property
    def uri(self):
        """
        Gets the uri of this NewUser.
        

        :return: The uri of this NewUser.
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """
        Sets the uri of this NewUser.
        

        :param uri: The uri of this NewUser.
        :type: str
        """

        self._uri = uri

    @property
    def user_id(self):
        """
        Gets the user_id of this NewUser.
        Specifies the user ID for the new user.

        :return: The user_id of this NewUser.
        :rtype: str
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """
        Sets the user_id of this NewUser.
        Specifies the user ID for the new user.

        :param user_id: The user_id of this NewUser.
        :type: str
        """

        self._user_id = user_id

    @property
    def user_name(self):
        """
        Gets the user_name of this NewUser.
        

        :return: The user_name of this NewUser.
        :rtype: str
        """
        return self._user_name

    @user_name.setter
    def user_name(self, user_name):
        """
        Sets the user_name of this NewUser.
        

        :param user_name: The user_name of this NewUser.
        :type: str
        """

        self._user_name = user_name

    @property
    def user_status(self):
        """
        Gets the user_status of this NewUser.
        

        :return: The user_status of this NewUser.
        :rtype: str
        """
        return self._user_status

    @user_status.setter
    def user_status(self, user_status):
        """
        Sets the user_status of this NewUser.
        

        :param user_status: The user_status of this NewUser.
        :type: str
        """

        self._user_status = user_status

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
