# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

    OpenAPI spec version: v2
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class SealSign(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, access_code=None, add_access_code_to_email=None, client_user_id=None, custom_fields=None, declined_date_time=None, declined_reason=None, delivered_date_time=None, delivery_method=None, document_visibility=None, email_notification=None, embedded_recipient_start_url=None, error_details=None, fax_number=None, id_check_configuration_name=None, id_check_information_input=None, inherit_email_notification_configuration=None, name=None, note=None, phone_authentication=None, recipient_attachments=None, recipient_authentication_status=None, recipient_id=None, recipient_id_guid=None, recipient_signature_providers=None, require_id_lookup=None, role_name=None, routing_order=None, saml_authentication=None, sent_date_time=None, signed_date_time=None, sms_authentication=None, social_authentications=None, status=None, tabs=None, template_locked=None, template_required=None, total_tab_count=None, user_id=None):
        """
        SealSign - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'access_code': 'str',
            'add_access_code_to_email': 'str',
            'client_user_id': 'str',
            'custom_fields': 'list[str]',
            'declined_date_time': 'str',
            'declined_reason': 'str',
            'delivered_date_time': 'str',
            'delivery_method': 'str',
            'document_visibility': 'list[DocumentVisibility]',
            'email_notification': 'RecipientEmailNotification',
            'embedded_recipient_start_url': 'str',
            'error_details': 'ErrorDetails',
            'fax_number': 'str',
            'id_check_configuration_name': 'str',
            'id_check_information_input': 'IdCheckInformationInput',
            'inherit_email_notification_configuration': 'str',
            'name': 'str',
            'note': 'str',
            'phone_authentication': 'RecipientPhoneAuthentication',
            'recipient_attachments': 'list[RecipientAttachment]',
            'recipient_authentication_status': 'AuthenticationStatus',
            'recipient_id': 'str',
            'recipient_id_guid': 'str',
            'recipient_signature_providers': 'list[RecipientSignatureProvider]',
            'require_id_lookup': 'str',
            'role_name': 'str',
            'routing_order': 'str',
            'saml_authentication': 'RecipientSAMLAuthentication',
            'sent_date_time': 'str',
            'signed_date_time': 'str',
            'sms_authentication': 'RecipientSMSAuthentication',
            'social_authentications': 'list[SocialAuthentication]',
            'status': 'str',
            'tabs': 'Tabs',
            'template_locked': 'str',
            'template_required': 'str',
            'total_tab_count': 'str',
            'user_id': 'str'
        }

        self.attribute_map = {
            'access_code': 'accessCode',
            'add_access_code_to_email': 'addAccessCodeToEmail',
            'client_user_id': 'clientUserId',
            'custom_fields': 'customFields',
            'declined_date_time': 'declinedDateTime',
            'declined_reason': 'declinedReason',
            'delivered_date_time': 'deliveredDateTime',
            'delivery_method': 'deliveryMethod',
            'document_visibility': 'documentVisibility',
            'email_notification': 'emailNotification',
            'embedded_recipient_start_url': 'embeddedRecipientStartURL',
            'error_details': 'errorDetails',
            'fax_number': 'faxNumber',
            'id_check_configuration_name': 'idCheckConfigurationName',
            'id_check_information_input': 'idCheckInformationInput',
            'inherit_email_notification_configuration': 'inheritEmailNotificationConfiguration',
            'name': 'name',
            'note': 'note',
            'phone_authentication': 'phoneAuthentication',
            'recipient_attachments': 'recipientAttachments',
            'recipient_authentication_status': 'recipientAuthenticationStatus',
            'recipient_id': 'recipientId',
            'recipient_id_guid': 'recipientIdGuid',
            'recipient_signature_providers': 'recipientSignatureProviders',
            'require_id_lookup': 'requireIdLookup',
            'role_name': 'roleName',
            'routing_order': 'routingOrder',
            'saml_authentication': 'samlAuthentication',
            'sent_date_time': 'sentDateTime',
            'signed_date_time': 'signedDateTime',
            'sms_authentication': 'smsAuthentication',
            'social_authentications': 'socialAuthentications',
            'status': 'status',
            'tabs': 'tabs',
            'template_locked': 'templateLocked',
            'template_required': 'templateRequired',
            'total_tab_count': 'totalTabCount',
            'user_id': 'userId'
        }

        self._access_code = access_code
        self._add_access_code_to_email = add_access_code_to_email
        self._client_user_id = client_user_id
        self._custom_fields = custom_fields
        self._declined_date_time = declined_date_time
        self._declined_reason = declined_reason
        self._delivered_date_time = delivered_date_time
        self._delivery_method = delivery_method
        self._document_visibility = document_visibility
        self._email_notification = email_notification
        self._embedded_recipient_start_url = embedded_recipient_start_url
        self._error_details = error_details
        self._fax_number = fax_number
        self._id_check_configuration_name = id_check_configuration_name
        self._id_check_information_input = id_check_information_input
        self._inherit_email_notification_configuration = inherit_email_notification_configuration
        self._name = name
        self._note = note
        self._phone_authentication = phone_authentication
        self._recipient_attachments = recipient_attachments
        self._recipient_authentication_status = recipient_authentication_status
        self._recipient_id = recipient_id
        self._recipient_id_guid = recipient_id_guid
        self._recipient_signature_providers = recipient_signature_providers
        self._require_id_lookup = require_id_lookup
        self._role_name = role_name
        self._routing_order = routing_order
        self._saml_authentication = saml_authentication
        self._sent_date_time = sent_date_time
        self._signed_date_time = signed_date_time
        self._sms_authentication = sms_authentication
        self._social_authentications = social_authentications
        self._status = status
        self._tabs = tabs
        self._template_locked = template_locked
        self._template_required = template_required
        self._total_tab_count = total_tab_count
        self._user_id = user_id

    @property
    def access_code(self):
        """
        Gets the access_code of this SealSign.
        If a value is provided, the recipient must enter the value as the access code to view and sign the envelope.   Maximum Length: 50 characters and it must conform to the account's access code format setting.  If blank, but the signer `accessCode` property is set in the envelope, then that value is used.  If blank and the signer `accessCode` property is not set, then the access code is not required.

        :return: The access_code of this SealSign.
        :rtype: str
        """
        return self._access_code

    @access_code.setter
    def access_code(self, access_code):
        """
        Sets the access_code of this SealSign.
        If a value is provided, the recipient must enter the value as the access code to view and sign the envelope.   Maximum Length: 50 characters and it must conform to the account's access code format setting.  If blank, but the signer `accessCode` property is set in the envelope, then that value is used.  If blank and the signer `accessCode` property is not set, then the access code is not required.

        :param access_code: The access_code of this SealSign.
        :type: str
        """

        self._access_code = access_code

    @property
    def add_access_code_to_email(self):
        """
        Gets the add_access_code_to_email of this SealSign.
        This Optional attribute indicates that the access code will be added to the email sent to the recipient; this nullifies the Security measure of Access Code on the recipient.

        :return: The add_access_code_to_email of this SealSign.
        :rtype: str
        """
        return self._add_access_code_to_email

    @add_access_code_to_email.setter
    def add_access_code_to_email(self, add_access_code_to_email):
        """
        Sets the add_access_code_to_email of this SealSign.
        This Optional attribute indicates that the access code will be added to the email sent to the recipient; this nullifies the Security measure of Access Code on the recipient.

        :param add_access_code_to_email: The add_access_code_to_email of this SealSign.
        :type: str
        """

        self._add_access_code_to_email = add_access_code_to_email

    @property
    def client_user_id(self):
        """
        Gets the client_user_id of this SealSign.
        Specifies whether the recipient is embedded or remote.   If the `clientUserId` property is not null then the recipient is embedded. Note that if the `ClientUserId` property is set and either `SignerMustHaveAccount` or `SignerMustLoginToSign` property of the account settings is set to  **true**, an error is generated on sending.ng.   Maximum length: 100 characters. 

        :return: The client_user_id of this SealSign.
        :rtype: str
        """
        return self._client_user_id

    @client_user_id.setter
    def client_user_id(self, client_user_id):
        """
        Sets the client_user_id of this SealSign.
        Specifies whether the recipient is embedded or remote.   If the `clientUserId` property is not null then the recipient is embedded. Note that if the `ClientUserId` property is set and either `SignerMustHaveAccount` or `SignerMustLoginToSign` property of the account settings is set to  **true**, an error is generated on sending.ng.   Maximum length: 100 characters. 

        :param client_user_id: The client_user_id of this SealSign.
        :type: str
        """

        self._client_user_id = client_user_id

    @property
    def custom_fields(self):
        """
        Gets the custom_fields of this SealSign.
        An optional array of strings that allows the sender to provide custom data about the recipient. This information is returned in the envelope status but otherwise not used by DocuSign. Each customField string can be a maximum of 100 characters.

        :return: The custom_fields of this SealSign.
        :rtype: list[str]
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """
        Sets the custom_fields of this SealSign.
        An optional array of strings that allows the sender to provide custom data about the recipient. This information is returned in the envelope status but otherwise not used by DocuSign. Each customField string can be a maximum of 100 characters.

        :param custom_fields: The custom_fields of this SealSign.
        :type: list[str]
        """

        self._custom_fields = custom_fields

    @property
    def declined_date_time(self):
        """
        Gets the declined_date_time of this SealSign.
        The date and time the recipient declined the document.

        :return: The declined_date_time of this SealSign.
        :rtype: str
        """
        return self._declined_date_time

    @declined_date_time.setter
    def declined_date_time(self, declined_date_time):
        """
        Sets the declined_date_time of this SealSign.
        The date and time the recipient declined the document.

        :param declined_date_time: The declined_date_time of this SealSign.
        :type: str
        """

        self._declined_date_time = declined_date_time

    @property
    def declined_reason(self):
        """
        Gets the declined_reason of this SealSign.
        The reason the recipient declined the document.

        :return: The declined_reason of this SealSign.
        :rtype: str
        """
        return self._declined_reason

    @declined_reason.setter
    def declined_reason(self, declined_reason):
        """
        Sets the declined_reason of this SealSign.
        The reason the recipient declined the document.

        :param declined_reason: The declined_reason of this SealSign.
        :type: str
        """

        self._declined_reason = declined_reason

    @property
    def delivered_date_time(self):
        """
        Gets the delivered_date_time of this SealSign.
        Reserved: For DocuSign use only.

        :return: The delivered_date_time of this SealSign.
        :rtype: str
        """
        return self._delivered_date_time

    @delivered_date_time.setter
    def delivered_date_time(self, delivered_date_time):
        """
        Sets the delivered_date_time of this SealSign.
        Reserved: For DocuSign use only.

        :param delivered_date_time: The delivered_date_time of this SealSign.
        :type: str
        """

        self._delivered_date_time = delivered_date_time

    @property
    def delivery_method(self):
        """
        Gets the delivery_method of this SealSign.
        Reserved: For DocuSign use only.

        :return: The delivery_method of this SealSign.
        :rtype: str
        """
        return self._delivery_method

    @delivery_method.setter
    def delivery_method(self, delivery_method):
        """
        Sets the delivery_method of this SealSign.
        Reserved: For DocuSign use only.

        :param delivery_method: The delivery_method of this SealSign.
        :type: str
        """

        self._delivery_method = delivery_method

    @property
    def document_visibility(self):
        """
        Gets the document_visibility of this SealSign.
        

        :return: The document_visibility of this SealSign.
        :rtype: list[DocumentVisibility]
        """
        return self._document_visibility

    @document_visibility.setter
    def document_visibility(self, document_visibility):
        """
        Sets the document_visibility of this SealSign.
        

        :param document_visibility: The document_visibility of this SealSign.
        :type: list[DocumentVisibility]
        """

        self._document_visibility = document_visibility

    @property
    def email_notification(self):
        """
        Gets the email_notification of this SealSign.

        :return: The email_notification of this SealSign.
        :rtype: RecipientEmailNotification
        """
        return self._email_notification

    @email_notification.setter
    def email_notification(self, email_notification):
        """
        Sets the email_notification of this SealSign.

        :param email_notification: The email_notification of this SealSign.
        :type: RecipientEmailNotification
        """

        self._email_notification = email_notification

    @property
    def embedded_recipient_start_url(self):
        """
        Gets the embedded_recipient_start_url of this SealSign.
        Specifies a sender provided valid URL string for redirecting an embedded recipient. When using this option, the embedded recipient still receives an email from DocuSign, just as a remote recipient would. When the document link in the email is clicked the recipient is redirected, through DocuSign, to the supplied URL to complete their actions. When routing to the URL, the sender's system (the server responding to the URL) must request a recipient token to launch a signing session.   If set to `SIGN_AT_DOCUSIGN`, the recipient is directed to an embedded signing or viewing process directly at DocuSign. The signing or viewing action is initiated by the DocuSign system and the transaction activity and Certificate of Completion records will reflect this. In all other ways the process is identical to an embedded signing or viewing operation that is launched by any partner.  It is important to remember that in a typical embedded workflow the authentication of an embedded recipient is the responsibility of the sending application, DocuSign expects that senders will follow their own process for establishing the recipient's identity. In this workflow the recipient goes through the sending application before the embedded signing or viewing process in initiated. However, when the sending application sets `EmbeddedRecipientStartURL=SIGN_AT_DOCUSIGN`, the recipient goes directly to the embedded signing or viewing process bypassing the sending application and any authentication steps the sending application would use. In this case, DocuSign recommends that you use one of the normal DocuSign authentication features (Access Code, Phone Authentication, SMS Authentication, etc.) to verify the identity of the recipient.  If the `clientUserId` property is NOT set, and the `embeddedRecipientStartURL` is set, DocuSign will ignore the redirect URL and launch the standard signing process for the email recipient. Information can be appended to the embedded recipient start URL using merge fields. The available merge fields items are: envelopeId, recipientId, recipientName, recipientEmail, and customFields. The `customFields` property must be set fort the recipient or envelope. The merge fields are enclosed in double brackets.   *Example*:   `http://senderHost/[[mergeField1]]/ beginSigningSession? [[mergeField2]]&[[mergeField3]]` 

        :return: The embedded_recipient_start_url of this SealSign.
        :rtype: str
        """
        return self._embedded_recipient_start_url

    @embedded_recipient_start_url.setter
    def embedded_recipient_start_url(self, embedded_recipient_start_url):
        """
        Sets the embedded_recipient_start_url of this SealSign.
        Specifies a sender provided valid URL string for redirecting an embedded recipient. When using this option, the embedded recipient still receives an email from DocuSign, just as a remote recipient would. When the document link in the email is clicked the recipient is redirected, through DocuSign, to the supplied URL to complete their actions. When routing to the URL, the sender's system (the server responding to the URL) must request a recipient token to launch a signing session.   If set to `SIGN_AT_DOCUSIGN`, the recipient is directed to an embedded signing or viewing process directly at DocuSign. The signing or viewing action is initiated by the DocuSign system and the transaction activity and Certificate of Completion records will reflect this. In all other ways the process is identical to an embedded signing or viewing operation that is launched by any partner.  It is important to remember that in a typical embedded workflow the authentication of an embedded recipient is the responsibility of the sending application, DocuSign expects that senders will follow their own process for establishing the recipient's identity. In this workflow the recipient goes through the sending application before the embedded signing or viewing process in initiated. However, when the sending application sets `EmbeddedRecipientStartURL=SIGN_AT_DOCUSIGN`, the recipient goes directly to the embedded signing or viewing process bypassing the sending application and any authentication steps the sending application would use. In this case, DocuSign recommends that you use one of the normal DocuSign authentication features (Access Code, Phone Authentication, SMS Authentication, etc.) to verify the identity of the recipient.  If the `clientUserId` property is NOT set, and the `embeddedRecipientStartURL` is set, DocuSign will ignore the redirect URL and launch the standard signing process for the email recipient. Information can be appended to the embedded recipient start URL using merge fields. The available merge fields items are: envelopeId, recipientId, recipientName, recipientEmail, and customFields. The `customFields` property must be set fort the recipient or envelope. The merge fields are enclosed in double brackets.   *Example*:   `http://senderHost/[[mergeField1]]/ beginSigningSession? [[mergeField2]]&[[mergeField3]]` 

        :param embedded_recipient_start_url: The embedded_recipient_start_url of this SealSign.
        :type: str
        """

        self._embedded_recipient_start_url = embedded_recipient_start_url

    @property
    def error_details(self):
        """
        Gets the error_details of this SealSign.

        :return: The error_details of this SealSign.
        :rtype: ErrorDetails
        """
        return self._error_details

    @error_details.setter
    def error_details(self, error_details):
        """
        Sets the error_details of this SealSign.

        :param error_details: The error_details of this SealSign.
        :type: ErrorDetails
        """

        self._error_details = error_details

    @property
    def fax_number(self):
        """
        Gets the fax_number of this SealSign.
        Reserved:

        :return: The fax_number of this SealSign.
        :rtype: str
        """
        return self._fax_number

    @fax_number.setter
    def fax_number(self, fax_number):
        """
        Sets the fax_number of this SealSign.
        Reserved:

        :param fax_number: The fax_number of this SealSign.
        :type: str
        """

        self._fax_number = fax_number

    @property
    def id_check_configuration_name(self):
        """
        Gets the id_check_configuration_name of this SealSign.
        Specifies authentication check by name. The names used here must be the same as the authentication type names used by the account (these name can also be found in the web console sending interface in the Identify list for a recipient,) This overrides any default authentication setting.  *Example*: Your account has ID Check and SMS Authentication available and in the web console Identify list these appear as 'ID Check $' and 'SMS Auth $'. To use ID check in an envelope, the idCheckConfigurationName should be 'ID Check '. If you wanted to use SMS, it would be 'SMS Auth $' and you would need to add you would need to add phone number information to the `smsAuthentication` node.

        :return: The id_check_configuration_name of this SealSign.
        :rtype: str
        """
        return self._id_check_configuration_name

    @id_check_configuration_name.setter
    def id_check_configuration_name(self, id_check_configuration_name):
        """
        Sets the id_check_configuration_name of this SealSign.
        Specifies authentication check by name. The names used here must be the same as the authentication type names used by the account (these name can also be found in the web console sending interface in the Identify list for a recipient,) This overrides any default authentication setting.  *Example*: Your account has ID Check and SMS Authentication available and in the web console Identify list these appear as 'ID Check $' and 'SMS Auth $'. To use ID check in an envelope, the idCheckConfigurationName should be 'ID Check '. If you wanted to use SMS, it would be 'SMS Auth $' and you would need to add you would need to add phone number information to the `smsAuthentication` node.

        :param id_check_configuration_name: The id_check_configuration_name of this SealSign.
        :type: str
        """

        self._id_check_configuration_name = id_check_configuration_name

    @property
    def id_check_information_input(self):
        """
        Gets the id_check_information_input of this SealSign.

        :return: The id_check_information_input of this SealSign.
        :rtype: IdCheckInformationInput
        """
        return self._id_check_information_input

    @id_check_information_input.setter
    def id_check_information_input(self, id_check_information_input):
        """
        Sets the id_check_information_input of this SealSign.

        :param id_check_information_input: The id_check_information_input of this SealSign.
        :type: IdCheckInformationInput
        """

        self._id_check_information_input = id_check_information_input

    @property
    def inherit_email_notification_configuration(self):
        """
        Gets the inherit_email_notification_configuration of this SealSign.
        When set to **true** and the envelope recipient creates a DocuSign account after signing, the Manage Account Email Notification settings are used as the default settings for the recipient's account. 

        :return: The inherit_email_notification_configuration of this SealSign.
        :rtype: str
        """
        return self._inherit_email_notification_configuration

    @inherit_email_notification_configuration.setter
    def inherit_email_notification_configuration(self, inherit_email_notification_configuration):
        """
        Sets the inherit_email_notification_configuration of this SealSign.
        When set to **true** and the envelope recipient creates a DocuSign account after signing, the Manage Account Email Notification settings are used as the default settings for the recipient's account. 

        :param inherit_email_notification_configuration: The inherit_email_notification_configuration of this SealSign.
        :type: str
        """

        self._inherit_email_notification_configuration = inherit_email_notification_configuration

    @property
    def name(self):
        """
        Gets the name of this SealSign.
        

        :return: The name of this SealSign.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this SealSign.
        

        :param name: The name of this SealSign.
        :type: str
        """

        self._name = name

    @property
    def note(self):
        """
        Gets the note of this SealSign.
        Specifies a note that is unique to this recipient. This note is sent to the recipient via the signing email. The note displays in the signing UI near the upper left corner of the document on the signing screen.  Maximum Length: 1000 characters.

        :return: The note of this SealSign.
        :rtype: str
        """
        return self._note

    @note.setter
    def note(self, note):
        """
        Sets the note of this SealSign.
        Specifies a note that is unique to this recipient. This note is sent to the recipient via the signing email. The note displays in the signing UI near the upper left corner of the document on the signing screen.  Maximum Length: 1000 characters.

        :param note: The note of this SealSign.
        :type: str
        """

        self._note = note

    @property
    def phone_authentication(self):
        """
        Gets the phone_authentication of this SealSign.

        :return: The phone_authentication of this SealSign.
        :rtype: RecipientPhoneAuthentication
        """
        return self._phone_authentication

    @phone_authentication.setter
    def phone_authentication(self, phone_authentication):
        """
        Sets the phone_authentication of this SealSign.

        :param phone_authentication: The phone_authentication of this SealSign.
        :type: RecipientPhoneAuthentication
        """

        self._phone_authentication = phone_authentication

    @property
    def recipient_attachments(self):
        """
        Gets the recipient_attachments of this SealSign.
        Reserved:

        :return: The recipient_attachments of this SealSign.
        :rtype: list[RecipientAttachment]
        """
        return self._recipient_attachments

    @recipient_attachments.setter
    def recipient_attachments(self, recipient_attachments):
        """
        Sets the recipient_attachments of this SealSign.
        Reserved:

        :param recipient_attachments: The recipient_attachments of this SealSign.
        :type: list[RecipientAttachment]
        """

        self._recipient_attachments = recipient_attachments

    @property
    def recipient_authentication_status(self):
        """
        Gets the recipient_authentication_status of this SealSign.

        :return: The recipient_authentication_status of this SealSign.
        :rtype: AuthenticationStatus
        """
        return self._recipient_authentication_status

    @recipient_authentication_status.setter
    def recipient_authentication_status(self, recipient_authentication_status):
        """
        Sets the recipient_authentication_status of this SealSign.

        :param recipient_authentication_status: The recipient_authentication_status of this SealSign.
        :type: AuthenticationStatus
        """

        self._recipient_authentication_status = recipient_authentication_status

    @property
    def recipient_id(self):
        """
        Gets the recipient_id of this SealSign.
        Unique for the recipient. It is used by the tab element to indicate which recipient is to sign the Document.

        :return: The recipient_id of this SealSign.
        :rtype: str
        """
        return self._recipient_id

    @recipient_id.setter
    def recipient_id(self, recipient_id):
        """
        Sets the recipient_id of this SealSign.
        Unique for the recipient. It is used by the tab element to indicate which recipient is to sign the Document.

        :param recipient_id: The recipient_id of this SealSign.
        :type: str
        """

        self._recipient_id = recipient_id

    @property
    def recipient_id_guid(self):
        """
        Gets the recipient_id_guid of this SealSign.
        

        :return: The recipient_id_guid of this SealSign.
        :rtype: str
        """
        return self._recipient_id_guid

    @recipient_id_guid.setter
    def recipient_id_guid(self, recipient_id_guid):
        """
        Sets the recipient_id_guid of this SealSign.
        

        :param recipient_id_guid: The recipient_id_guid of this SealSign.
        :type: str
        """

        self._recipient_id_guid = recipient_id_guid

    @property
    def recipient_signature_providers(self):
        """
        Gets the recipient_signature_providers of this SealSign.
        

        :return: The recipient_signature_providers of this SealSign.
        :rtype: list[RecipientSignatureProvider]
        """
        return self._recipient_signature_providers

    @recipient_signature_providers.setter
    def recipient_signature_providers(self, recipient_signature_providers):
        """
        Sets the recipient_signature_providers of this SealSign.
        

        :param recipient_signature_providers: The recipient_signature_providers of this SealSign.
        :type: list[RecipientSignatureProvider]
        """

        self._recipient_signature_providers = recipient_signature_providers

    @property
    def require_id_lookup(self):
        """
        Gets the require_id_lookup of this SealSign.
        When set to **true**, the recipient is required to use the specified ID check method (including Phone and SMS authentication) to validate their identity. 

        :return: The require_id_lookup of this SealSign.
        :rtype: str
        """
        return self._require_id_lookup

    @require_id_lookup.setter
    def require_id_lookup(self, require_id_lookup):
        """
        Sets the require_id_lookup of this SealSign.
        When set to **true**, the recipient is required to use the specified ID check method (including Phone and SMS authentication) to validate their identity. 

        :param require_id_lookup: The require_id_lookup of this SealSign.
        :type: str
        """

        self._require_id_lookup = require_id_lookup

    @property
    def role_name(self):
        """
        Gets the role_name of this SealSign.
        Optional element. Specifies the role name associated with the recipient.<br/><br/>This is required when working with template recipients.

        :return: The role_name of this SealSign.
        :rtype: str
        """
        return self._role_name

    @role_name.setter
    def role_name(self, role_name):
        """
        Sets the role_name of this SealSign.
        Optional element. Specifies the role name associated with the recipient.<br/><br/>This is required when working with template recipients.

        :param role_name: The role_name of this SealSign.
        :type: str
        """

        self._role_name = role_name

    @property
    def routing_order(self):
        """
        Gets the routing_order of this SealSign.
        Specifies the routing order of the recipient in the envelope. 

        :return: The routing_order of this SealSign.
        :rtype: str
        """
        return self._routing_order

    @routing_order.setter
    def routing_order(self, routing_order):
        """
        Sets the routing_order of this SealSign.
        Specifies the routing order of the recipient in the envelope. 

        :param routing_order: The routing_order of this SealSign.
        :type: str
        """

        self._routing_order = routing_order

    @property
    def saml_authentication(self):
        """
        Gets the saml_authentication of this SealSign.

        :return: The saml_authentication of this SealSign.
        :rtype: RecipientSAMLAuthentication
        """
        return self._saml_authentication

    @saml_authentication.setter
    def saml_authentication(self, saml_authentication):
        """
        Sets the saml_authentication of this SealSign.

        :param saml_authentication: The saml_authentication of this SealSign.
        :type: RecipientSAMLAuthentication
        """

        self._saml_authentication = saml_authentication

    @property
    def sent_date_time(self):
        """
        Gets the sent_date_time of this SealSign.
        The date and time the envelope was sent.

        :return: The sent_date_time of this SealSign.
        :rtype: str
        """
        return self._sent_date_time

    @sent_date_time.setter
    def sent_date_time(self, sent_date_time):
        """
        Sets the sent_date_time of this SealSign.
        The date and time the envelope was sent.

        :param sent_date_time: The sent_date_time of this SealSign.
        :type: str
        """

        self._sent_date_time = sent_date_time

    @property
    def signed_date_time(self):
        """
        Gets the signed_date_time of this SealSign.
        Reserved: For DocuSign use only. 

        :return: The signed_date_time of this SealSign.
        :rtype: str
        """
        return self._signed_date_time

    @signed_date_time.setter
    def signed_date_time(self, signed_date_time):
        """
        Sets the signed_date_time of this SealSign.
        Reserved: For DocuSign use only. 

        :param signed_date_time: The signed_date_time of this SealSign.
        :type: str
        """

        self._signed_date_time = signed_date_time

    @property
    def sms_authentication(self):
        """
        Gets the sms_authentication of this SealSign.

        :return: The sms_authentication of this SealSign.
        :rtype: RecipientSMSAuthentication
        """
        return self._sms_authentication

    @sms_authentication.setter
    def sms_authentication(self, sms_authentication):
        """
        Sets the sms_authentication of this SealSign.

        :param sms_authentication: The sms_authentication of this SealSign.
        :type: RecipientSMSAuthentication
        """

        self._sms_authentication = sms_authentication

    @property
    def social_authentications(self):
        """
        Gets the social_authentications of this SealSign.
         Lists the social ID type that can be used for recipient authentication.

        :return: The social_authentications of this SealSign.
        :rtype: list[SocialAuthentication]
        """
        return self._social_authentications

    @social_authentications.setter
    def social_authentications(self, social_authentications):
        """
        Sets the social_authentications of this SealSign.
         Lists the social ID type that can be used for recipient authentication.

        :param social_authentications: The social_authentications of this SealSign.
        :type: list[SocialAuthentication]
        """

        self._social_authentications = social_authentications

    @property
    def status(self):
        """
        Gets the status of this SealSign.
        Indicates the envelope status. Valid values are:  * sent - The envelope is sent to the recipients.  * created - The envelope is saved as a draft and can be modified and sent later.

        :return: The status of this SealSign.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this SealSign.
        Indicates the envelope status. Valid values are:  * sent - The envelope is sent to the recipients.  * created - The envelope is saved as a draft and can be modified and sent later.

        :param status: The status of this SealSign.
        :type: str
        """

        self._status = status

    @property
    def tabs(self):
        """
        Gets the tabs of this SealSign.

        :return: The tabs of this SealSign.
        :rtype: Tabs
        """
        return self._tabs

    @tabs.setter
    def tabs(self, tabs):
        """
        Sets the tabs of this SealSign.

        :param tabs: The tabs of this SealSign.
        :type: Tabs
        """

        self._tabs = tabs

    @property
    def template_locked(self):
        """
        Gets the template_locked of this SealSign.
        When set to **true**, the sender cannot change any attributes of the recipient. Used only when working with template recipients. 

        :return: The template_locked of this SealSign.
        :rtype: str
        """
        return self._template_locked

    @template_locked.setter
    def template_locked(self, template_locked):
        """
        Sets the template_locked of this SealSign.
        When set to **true**, the sender cannot change any attributes of the recipient. Used only when working with template recipients. 

        :param template_locked: The template_locked of this SealSign.
        :type: str
        """

        self._template_locked = template_locked

    @property
    def template_required(self):
        """
        Gets the template_required of this SealSign.
        When set to **true**, the sender may not remove the recipient. Used only when working with template recipients.

        :return: The template_required of this SealSign.
        :rtype: str
        """
        return self._template_required

    @template_required.setter
    def template_required(self, template_required):
        """
        Sets the template_required of this SealSign.
        When set to **true**, the sender may not remove the recipient. Used only when working with template recipients.

        :param template_required: The template_required of this SealSign.
        :type: str
        """

        self._template_required = template_required

    @property
    def total_tab_count(self):
        """
        Gets the total_tab_count of this SealSign.
        

        :return: The total_tab_count of this SealSign.
        :rtype: str
        """
        return self._total_tab_count

    @total_tab_count.setter
    def total_tab_count(self, total_tab_count):
        """
        Sets the total_tab_count of this SealSign.
        

        :param total_tab_count: The total_tab_count of this SealSign.
        :type: str
        """

        self._total_tab_count = total_tab_count

    @property
    def user_id(self):
        """
        Gets the user_id of this SealSign.
        

        :return: The user_id of this SealSign.
        :rtype: str
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """
        Sets the user_id of this SealSign.
        

        :param user_id: The user_id of this SealSign.
        :type: str
        """

        self._user_id = user_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
