# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

    OpenAPI spec version: v2
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class TemplateSummary(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, applied=None, document_id=None, document_name=None, name=None, template_id=None, template_match=None, uri=None):
        """
        TemplateSummary - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'applied': 'str',
            'document_id': 'str',
            'document_name': 'str',
            'name': 'str',
            'template_id': 'str',
            'template_match': 'TemplateMatch',
            'uri': 'str'
        }

        self.attribute_map = {
            'applied': 'applied',
            'document_id': 'documentId',
            'document_name': 'documentName',
            'name': 'name',
            'template_id': 'templateId',
            'template_match': 'templateMatch',
            'uri': 'uri'
        }

        self._applied = applied
        self._document_id = document_id
        self._document_name = document_name
        self._name = name
        self._template_id = template_id
        self._template_match = template_match
        self._uri = uri

    @property
    def applied(self):
        """
        Gets the applied of this TemplateSummary.
        Reserved: TBD

        :return: The applied of this TemplateSummary.
        :rtype: str
        """
        return self._applied

    @applied.setter
    def applied(self, applied):
        """
        Sets the applied of this TemplateSummary.
        Reserved: TBD

        :param applied: The applied of this TemplateSummary.
        :type: str
        """

        self._applied = applied

    @property
    def document_id(self):
        """
        Gets the document_id of this TemplateSummary.
        Specifies the document ID number that the tab is placed on. This must refer to an existing Document's ID attribute.

        :return: The document_id of this TemplateSummary.
        :rtype: str
        """
        return self._document_id

    @document_id.setter
    def document_id(self, document_id):
        """
        Sets the document_id of this TemplateSummary.
        Specifies the document ID number that the tab is placed on. This must refer to an existing Document's ID attribute.

        :param document_id: The document_id of this TemplateSummary.
        :type: str
        """

        self._document_id = document_id

    @property
    def document_name(self):
        """
        Gets the document_name of this TemplateSummary.
        

        :return: The document_name of this TemplateSummary.
        :rtype: str
        """
        return self._document_name

    @document_name.setter
    def document_name(self, document_name):
        """
        Sets the document_name of this TemplateSummary.
        

        :param document_name: The document_name of this TemplateSummary.
        :type: str
        """

        self._document_name = document_name

    @property
    def name(self):
        """
        Gets the name of this TemplateSummary.
        

        :return: The name of this TemplateSummary.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this TemplateSummary.
        

        :param name: The name of this TemplateSummary.
        :type: str
        """

        self._name = name

    @property
    def template_id(self):
        """
        Gets the template_id of this TemplateSummary.
        The unique identifier of the template. If this is not provided, DocuSign will generate a value. 

        :return: The template_id of this TemplateSummary.
        :rtype: str
        """
        return self._template_id

    @template_id.setter
    def template_id(self, template_id):
        """
        Sets the template_id of this TemplateSummary.
        The unique identifier of the template. If this is not provided, DocuSign will generate a value. 

        :param template_id: The template_id of this TemplateSummary.
        :type: str
        """

        self._template_id = template_id

    @property
    def template_match(self):
        """
        Gets the template_match of this TemplateSummary.

        :return: The template_match of this TemplateSummary.
        :rtype: TemplateMatch
        """
        return self._template_match

    @template_match.setter
    def template_match(self, template_match):
        """
        Sets the template_match of this TemplateSummary.

        :param template_match: The template_match of this TemplateSummary.
        :type: TemplateMatch
        """

        self._template_match = template_match

    @property
    def uri(self):
        """
        Gets the uri of this TemplateSummary.
        

        :return: The uri of this TemplateSummary.
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """
        Sets the uri of this TemplateSummary.
        

        :param uri: The uri of this TemplateSummary.
        :type: str
        """

        self._uri = uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
